var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import ink from "@writewithocto/ink";
import { defineComponent, openBlock, createElementBlock } from "vue";
var _export_sfc = (sfc, props) => {
  const target = sfc.__vccOpts || sfc;
  for (const [key, val] of props) {
    target[key] = val;
  }
  return target;
};
const _sfc_main = defineComponent({
  name: "Ink",
  emits: ["input", "update:modelValue"],
  props: {
    options: {
      type: Object
    },
    modelValue: {
      type: String
    },
    value: {
      type: String
    },
    version: {
      type: Number,
      default: () => 3,
      validator: (value) => [2, 3].includes(value)
    }
  },
  data() {
    return { instance: void 0 };
  },
  watch: {
    options: {
      deep: true,
      handler(newValue, _oldValue) {
        var _a;
        (_a = this.instance) == null ? void 0 : _a.reconfigure(newValue);
      }
    },
    modelValue(value) {
      var _a, _b;
      if (((_a = this.instance) == null ? void 0 : _a.doc()) !== value) {
        (_b = this.instance) == null ? void 0 : _b.update(value);
      }
    },
    value(value) {
      var _a, _b;
      if (((_a = this.instance) == null ? void 0 : _a.doc()) !== value) {
        (_b = this.instance) == null ? void 0 : _b.update(value);
      }
    }
  },
  computed: {
    doc() {
      return (this.version === 3 ? this.modelValue : this.value) || "";
    }
  },
  methods: {
    focus() {
      var _a;
      (_a = this.instance) == null ? void 0 : _a.focus();
    },
    select(selections) {
      var _a;
      (_a = this.instance) == null ? void 0 : _a.select(selections);
    },
    selections() {
      var _a;
      return (_a = this.instance) == null ? void 0 : _a.selections();
    }
  },
  mounted() {
    var _a;
    this.instance = ink(this.$refs.ink, __spreadProps(__spreadValues({}, this.options), {
      doc: this.doc,
      hooks: __spreadProps(__spreadValues({}, (_a = this.options) == null ? void 0 : _a.hooks), {
        afterUpdate: (doc) => {
          var _a2, _b;
          if (this.version === 3) {
            this.$emit("update:modelValue", doc);
          } else {
            this.$emit("input", doc);
          }
          if ((_b = (_a2 = this.options) == null ? void 0 : _a2.hooks) == null ? void 0 : _b.afterUpdate) {
            this.options.hooks.afterUpdate(doc);
          }
        }
      })
    }));
    this.$refs.ink.addEventListener("input", (event) => {
      event.stopPropagation();
    });
    this.instance.focus();
  }
});
const _hoisted_1 = { ref: "ink" };
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1, null, 512);
}
var Ink = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export { Ink as default };
